Package org.optaplanner.core.api.score.buildin.hardsoftdouble

## Class HardSoftDoubleScore

- java.lang.Object
- - org.optaplanner.core.api.score.AbstractScore<HardSoftDoubleScore>
  - - org.optaplanner.core.api.score.buildin.hardsoftdouble.HardSoftDoubleScore

- All Implemented Interfaces:
    `Serializable`, `Comparable<HardSoftDoubleScore>`, `FeasibilityScore<HardSoftDoubleScore>`, `Score<HardSoftDoubleScore>`

      @Deprecated
      public final class HardSoftDoubleScore
      extends AbstractScore<HardSoftDoubleScore>
      implements FeasibilityScore<HardSoftDoubleScore>

  Deprecated.
  Double-based scores are deprecated as floating point numbers are not associative (A + B + C == C + B + A) and therefore they are not compatible with incremental score calculation. Use `HardSoftBigDecimalScore` or a scaled `HardSoftLongScore` instead.
  This `Score` is based on 2 levels of double constraints: hard and soft. Hard constraints have priority over soft constraints. Hard constraints determine feasibility.

  WARNING: NOT RECOMMENDED TO USE DUE TO ROUNDING ERRORS THAT CAUSE SCORE CORRUPTION. For example, this prints false: `System.out.println((0.01 + 0.05) == (0.01 + 0.02 + 0.03));` Use `HardSoftBigDecimalScore` instead.

  This class is immutable.

  See Also:
    `Score`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static HardSoftDoubleScore` | `ONE_HARD` | Deprecated.
    `static HardSoftDoubleScore` | `ONE_SOFT` | Deprecated.
    `static HardSoftDoubleScore` | `ZERO` | Deprecated.

    - ### Fields inherited from class org.optaplanner.core.api.score.AbstractScore

      `INIT_LABEL, initScore`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HardSoftDoubleScore` | `add​(HardSoftDoubleScore addend)` | Deprecated. Returns a Score whose value is (this + addend).
    `int` | `compareTo​(HardSoftDoubleScore other)` | Deprecated.
    `HardSoftDoubleScore` | `divide​(double divisor)` | Deprecated. Returns a Score whose value is (this / divisor).
    `boolean` | `equals​(Object o)` | Deprecated.
    `double` | `getHardScore()` | Deprecated. The total of the broken negative hard constraints and fulfilled positive hard constraints.
    `double` | `getSoftScore()` | Deprecated. The total of the broken negative soft constraints and fulfilled positive soft constraints.
    `int` | `hashCode()` | Deprecated.
    `boolean` | `isCompatibleArithmeticArgument​(Score otherScore)` | Deprecated.
    `boolean` | `isFeasible()` | Deprecated. A `PlanningSolution` is feasible if it has no broken hard constraints and `Score.isSolutionInitialized()` is true.
    `HardSoftDoubleScore` | `multiply​(double multiplicand)` | Deprecated. Returns a Score whose value is (this * multiplicand).
    `HardSoftDoubleScore` | `negate()` | Deprecated. Returns a Score whose value is (- this).
    `static HardSoftDoubleScore` | `of​(double hardScore, double softScore)` | Deprecated.
    `static HardSoftDoubleScore` | `ofHard​(double hardScore)` | Deprecated.
    `static HardSoftDoubleScore` | `ofSoft​(double softScore)` | Deprecated.
    `static HardSoftDoubleScore` | `ofUninitialized​(int initScore, double hardScore, double softScore)` | Deprecated.
    `static HardSoftDoubleScore` | `parseScore​(String scoreString)` | Deprecated.
    `HardSoftDoubleScore` | `power​(double exponent)` | Deprecated. Returns a Score whose value is (this ^ exponent).
    `HardSoftDoubleScore` | `subtract​(HardSoftDoubleScore subtrahend)` | Deprecated. Returns a Score whose value is (this - subtrahend).
    `Number[]` | `toLevelNumbers()` | Deprecated. Returns an array of numbers representing the Score.
    `String` | `toShortString()` | Deprecated. Like `Object.toString()`, but trims score levels which have a zero weight.
    `String` | `toString()` | Deprecated.
    `static HardSoftDoubleScore` | `valueOf​(double hardScore, double softScore)` | Deprecated. in favor of `of(double, double)`
    `static HardSoftDoubleScore` | `valueOfUninitialized​(int initScore, double hardScore, double softScore)` | Deprecated. in favor of `ofUninitialized(int, double, double)`
    `HardSoftDoubleScore` | `withInitScore​(int newInitScore)` | Deprecated. For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.

    - ### Methods inherited from class org.optaplanner.core.api.score.AbstractScore

      `assertNoInitScore, buildScorePattern, buildShortString, getInitPrefix, getInitScore, isSolutionInitialized, parseInitScore, parseLevelAsBigDecimal, parseLevelAsDouble, parseLevelAsInt, parseLevelAsLong, parseScoreTokens`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.Score

      `getInitScore, isSolutionInitialized, toInitializedScore`

- - ### Field Detail

    - #### ZERO

          public static final HardSoftDoubleScore ZERO

      Deprecated.

    - #### ONE_HARD

          public static final HardSoftDoubleScore ONE_HARD

      Deprecated.

    - #### ONE_SOFT

          public static final HardSoftDoubleScore ONE_SOFT

      Deprecated.

  - ### Method Detail

    - #### parseScore

          public static HardSoftDoubleScore parseScore​(String scoreString)

      Deprecated.

    - #### ofUninitialized

          public static HardSoftDoubleScore ofUninitialized​(int initScore,
                                                            double hardScore,
                                                            double softScore)

      Deprecated.

    - #### valueOfUninitialized

          @Deprecated
          public static HardSoftDoubleScore valueOfUninitialized​(int initScore,
                                                                 double hardScore,
                                                                 double softScore)

      Deprecated.
      in favor of `ofUninitialized(int, double, double)`

    - #### of

          public static HardSoftDoubleScore of​(double hardScore,
                                               double softScore)

      Deprecated.

    - #### valueOf

          @Deprecated
          public static HardSoftDoubleScore valueOf​(double hardScore,
                                                    double softScore)

      Deprecated.
      in favor of `of(double, double)`

    - #### ofHard

          public static HardSoftDoubleScore ofHard​(double hardScore)

      Deprecated.

    - #### ofSoft

          public static HardSoftDoubleScore ofSoft​(double softScore)

      Deprecated.

    - #### getHardScore

          public double getHardScore()

      Deprecated.
      The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.
      Returns:
        higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

    - #### getSoftScore

          public double getSoftScore()

      Deprecated.
      The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

      In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard score.

      Returns:
        higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

    - #### withInitScore

          public HardSoftDoubleScore withInitScore​(int newInitScore)

      Deprecated.
      Description copied from interface: `Score`
      For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.
      Specified by:
        `withInitScore` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `newInitScore` - always negative (except in statistical calculations), 0 if all planning variables are initialized
      Returns:
        equals score except that `Score.getInitScore()` is set to `newInitScore`

    - #### isFeasible

          public boolean isFeasible()

      Deprecated.
      Description copied from interface: `FeasibilityScore`
      A `PlanningSolution` is feasible if it has no broken hard constraints and `Score.isSolutionInitialized()` is true.
      Specified by:
        `isFeasible` in interface `FeasibilityScore<HardSoftDoubleScore>`
      Specified by:
        `isFeasible` in interface `Score<HardSoftDoubleScore>`
      Returns:
        true if the hard score is 0 or higher and the `Score.getInitScore()` is 0.

    - #### add

          public HardSoftDoubleScore add​(HardSoftDoubleScore addend)

      Deprecated.
      Description copied from interface: `Score`
      Returns a Score whose value is (this + addend).
      Specified by:
        `add` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `addend` - value to be added to this Score
      Returns:
        this + addend

    - #### subtract

          public HardSoftDoubleScore subtract​(HardSoftDoubleScore subtrahend)

      Deprecated.
      Description copied from interface: `Score`
      Returns a Score whose value is (this - subtrahend).
      Specified by:
        `subtract` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `subtrahend` - value to be subtracted from this Score
      Returns:
        this - subtrahend, rounded as necessary

    - #### multiply

          public HardSoftDoubleScore multiply​(double multiplicand)

      Deprecated.
      Description copied from interface: `Score`
      Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

      Specified by:
        `multiply` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `multiplicand` - value to be multiplied by this Score.
      Returns:
        this * multiplicand

    - #### divide

          public HardSoftDoubleScore divide​(double divisor)

      Deprecated.
      Description copied from interface: `Score`
      Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

      Specified by:
        `divide` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor

    - #### power

          public HardSoftDoubleScore power​(double exponent)

      Deprecated.
      Description copied from interface: `Score`
      Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

      Specified by:
        `power` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `exponent` - value by which this Score is to be powered
      Returns:
        this ^ exponent

    - #### negate

          public HardSoftDoubleScore negate()

      Deprecated.
      Description copied from interface: `Score`
      Returns a Score whose value is (- this).
      Specified by:
        `negate` in interface `Score<HardSoftDoubleScore>`
      Returns:
        - this

    - #### toLevelNumbers

          public Number[] toLevelNumbers()

      Deprecated.
      Description copied from interface: `Score`
      Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

      When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`). The length of the returned array must be stable for a specific `Score` implementation.

      For example: `-0hard/-7soft` returns `new int{-0, -7}`

      The level numbers do not contain the `Score.getInitScore()`. For example: `-3init/-0hard/-7soft` also returns `new int{-0, -7}`

      Specified by:
        `toLevelNumbers` in interface `Score<HardSoftDoubleScore>`
      Returns:
        never null
      See Also:
        `ScoreDefinition.fromLevelNumbers(int, Number[])`

    - #### equals

          public boolean equals​(Object o)

      Deprecated.
      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Deprecated.
      Overrides:
        `hashCode` in class `Object`

    - #### compareTo

          public int compareTo​(HardSoftDoubleScore other)

      Deprecated.
      Specified by:
        `compareTo` in interface `Comparable<HardSoftDoubleScore>`

    - #### toShortString

          public String toShortString()

      Deprecated.
      Description copied from interface: `Score`
      Like `Object.toString()`, but trims score levels which have a zero weight. For example 0hard/-258soft returns -258soft.

      Do not use this format to persist information as text, use `Object.toString()` instead, so it can be parsed reliably.

      Specified by:
        `toShortString` in interface `Score<HardSoftDoubleScore>`
      Returns:
        never null

    - #### toString

          public String toString()

      Deprecated.
      Overrides:
        `toString` in class `Object`

    - #### isCompatibleArithmeticArgument

          public boolean isCompatibleArithmeticArgument​(Score otherScore)

      Deprecated.
      Specified by:
        `isCompatibleArithmeticArgument` in interface `Score<HardSoftDoubleScore>`
      Parameters:
        `otherScore` - never null
      Returns:
        true if the otherScore is accepted as a parameter of `Score.add(Score)`, `Score.subtract(Score)` and `Comparable.compareTo(Object)`.